summaryrefslogtreecommitdiffstats
path: root/docker
diff options
context:
space:
mode:
Diffstat (limited to 'docker')
-rw-r--r--docker/README.md43
-rwxr-xr-xdocker/add_user.sh4
-rw-r--r--docker/docker-compose.yml29
-rwxr-xr-xdocker/filebin_starter.sh88
4 files changed, 164 insertions, 0 deletions
diff --git a/docker/README.md b/docker/README.md
new file mode 100644
index 000000000..775afa1de
--- /dev/null
+++ b/docker/README.md
@@ -0,0 +1,43 @@
+# Filebin Docker Container
+
+## Filebin
+Filebin is a paste service developed by Florian Pritz [https://paste.xinu.at/](https://paste.xinu.at/)
+
+## Dockerfile
+[Dockerfile](https://git.server-speed.net/users/flo/filebin/tree/docker/Dockerfile)
+
+## Ports
+The PHP webserver is listening on ```8080```
+
+## Volumes
+
+- **Uploaded Data:** uploaded files are saved to ```/var/lib/filebin/filebin/data/uploads```
+- **Advanced Configuration:** the configuration is located at ```/var/lib/filebin/filebin/application/config```
+
+## Environment Variables
+- **FB_DB_HOSTNAME:** the hostname of the mysql/mariadb server
+- **FB_DB_USERNAME:** the username for the mysql/mariadb server
+- **FB_DB_PASSWORD:** the password for the mysql/mariadb server
+- **FB_DB_DATABASE:** the database on the mysql/mariadb for Filebin
+
+- **FB_CONTACT_NAME:** Contact Name
+- **FB_CONTACT_MAIL:** Contact E-Mail (will be used as email for the first user)
+
+- **FB_SMTP_HOST:** Address of the SMTP Server
+- **FB_SMTP_PORT:** Port for SMTP Server (default 587)
+- **FB_SMTP_USER:** Username for SMTP Server (will also be used as mail from)
+- **FB_SMTP_PASSWORD:** Password for the SMTP Server Useraccount
+
+## First User
+The first user is **admin** with the password **admin**
+
+## Run
+
+### with docker-compose
+```bash
+docker-compose build
+docker-compose up
+```
+
+### with linked mysql/mariadb database server
+```docker run -ti --rm -p <port>:8080 --link mdb:mysql -e FB_DB_HOSTNAME=mysql -e FB_DB_USERNAME=filebin_usr -e FB_DB_PASSWORD=test -e FB_DB_DATABASE=filebin -e FB_CONTACT_NAME="John Doe" -e FB_CONTACT_MAIL="john.doe@localmail.local" sebastianrakel/filebin```
diff --git a/docker/add_user.sh b/docker/add_user.sh
new file mode 100755
index 000000000..4342528ef
--- /dev/null
+++ b/docker/add_user.sh
@@ -0,0 +1,4 @@
+#!/bin/bash
+
+cd ${FILEBIN_DIR}
+printf "%s\n%s\n%s\n" admin ${FB_CONTACT_MAIL} admin | php index.php user add_user
diff --git a/docker/docker-compose.yml b/docker/docker-compose.yml
new file mode 100644
index 000000000..7450f6903
--- /dev/null
+++ b/docker/docker-compose.yml
@@ -0,0 +1,29 @@
+version: '2'
+services:
+ mysql:
+ image: mysql
+ environment:
+ - MYSQL_DATABASE=filebin
+ - MYSQL_USER=filebin
+ # TODO: can this be set to a random password?
+ - MYSQL_PASSWORD=filebin-docker-demo
+ - MYSQL_RANDOM_ROOT_PASSWORD=yes
+
+ filebin:
+ links:
+ - mysql
+ build: ..
+ ports:
+ - "8080:8080"
+ environment:
+ - FB_DB_HOSTNAME=mysql
+ - FB_DB_USERNAME=filebin
+ - FB_DB_PASSWORD=filebin-docker-demo
+ - FB_DB_DATABASE=filebin
+ - FB_CONTACT_NAME=John Doe
+ - FB_CONTACT_MAIL=root@example.local
+ - FB_SMTP_HOST=localhost
+ - FB_SMTP_PORT=587
+ - FB_SMTP_USER=webmaster@example.invalid
+ - FB_SMTP_PASSWORD=mysecretpassword
+
diff --git a/docker/filebin_starter.sh b/docker/filebin_starter.sh
new file mode 100755
index 000000000..66f9a8b03
--- /dev/null
+++ b/docker/filebin_starter.sh
@@ -0,0 +1,88 @@
+#!/bin/bash
+
+#set -euo pipefail
+
+function set_mail_config() {
+cat <<EOF > ${FILEBIN_HOME_DIR}/msmtprc
+account filebinmail
+tls on
+tls_certcheck off
+auth on
+host ${FB_SMTP_HOST}
+port ${FB_SMTP_PORT}
+user ${FB_SMTP_USER}
+from ${FB_SMTP_USER}
+password ${FB_SMTP_PASSWORD}
+EOF
+
+chmod 600 ${FILEBIN_HOME_DIR}/msmtprc
+}
+
+function set_config() {
+ FB_ENCRYPTION_KEY=`< /dev/urandom tr -dc _A-Z-a-z-0-9 | head -c32`
+cat <<EOF >${FILEBIN_DIR}/application/config/config-local.php
+<?php
+\$config['base_url'] = 'http://127.0.0.1:8080/';
+\$config['encryption_key'] = '${FB_ENCRYPTION_KEY}';
+\$config['email_from'] = '${FB_SMTP_USER}';
+EOF
+}
+
+function set_database_config() {
+cat <<EOF >${FILEBIN_DIR}/application/config/database.php
+<?php
+defined('BASEPATH') OR exit('No direct script access allowed');
+\$active_group = 'default';
+\$query_builder = TRUE;
+
+\$db['default'] = array(
+ 'dsn' => 'mysql:host=${FB_DB_HOSTNAME};dbname=${FB_DB_DATABASE}',
+ 'hostname' => '',
+ 'port' => 3306,
+ 'username' => '${FB_DB_USERNAME}',
+ 'password' => '${FB_DB_PASSWORD}',
+ 'database' => '',
+ 'dbdriver' => 'pdo',
+ 'dbprefix' => '',
+ 'pconnect' => FALSE,
+ 'db_debug' => TRUE,
+ 'char_set' => 'utf8mb4', // if you use postgres, set this to utf8
+ 'dbcollat' => 'utf8mb4_bin', // if you use postgres, set this to utf8_bin
+ 'swap_pre' => '',
+ 'encrypt' => FALSE,
+ 'compress' => FALSE,
+ 'stricton' => TRUE,
+ 'failover' => array(),
+ 'save_queries' => TRUE
+);
+EOF
+}
+
+# wait for DB to be ready
+while ! nc "$FB_DB_HOSTNAME" 3306 </dev/null >/dev/null; do
+ echo "Waiting for database"
+ sleep 0.5
+done
+
+
+if [[ ! -e $FILEBIN_DIR/application/config/config-local.php ]]; then
+ echo "no config found, new config will be generated"
+
+ set_config
+ set_database_config
+ set_mail_config
+
+ CONTACT_INFO_FILE=${FILEBIN_DIR}/data/local/contact-info.php
+ cp $FILEBIN_DIR/data/local/examples/contact-info.php ${CONTACT_INFO_FILE}
+
+ sed -i "s/John Doe/${FB_CONTACT_NAME}/" ${CONTACT_INFO_FILE}
+ sed -i "s/john.doe@example.com/${FB_CONTACT_MAIL}/" ${CONTACT_INFO_FILE}
+
+ ${FILEBIN_DIR}/scripts/install-git-hooks.sh
+ ${FILEBIN_DIR}/git-hooks/post-merge
+
+ ${FILEBIN_HOME_DIR}/add_user.sh
+fi
+
+cd $FILEBIN_DIR/public_html
+php -S 0.0.0.0:8080